/**
 * @file SerialBuffer.cpp
 *
 * @brief Classes to represent serial buffer
 *
 * @ingroup System Utilities
 *
 * @author Devon Johnson
 *
 */

// Includes
#include <System/SerialBuffer.h>
#include <System/Serializable.h>

namespace System
{
  /////////////////////////////////////////////////////////////////////////////
  // hostToNetwork
  /////////////////////////////////////////////////////////////////////////////
  MsgHeader MsgHeader::hostToNetwork() const
  {
    MsgHeader other;
    other.id = ByteOrdering::ToBigEndian(id);
    other.length = ByteOrdering::ToBigEndian(length);
    return other;
  }

  /////////////////////////////////////////////////////////////////////////////
  // networkToHost
  /////////////////////////////////////////////////////////////////////////////
  MsgHeader MsgHeader::networkToHost() const
  {
    MsgHeader other;
    other.id = ByteOrdering::FromBigEndian(id);
    other.length = ByteOrdering::FromBigEndian(length);
    return other;
  }

  /////////////////////////////////////////////////////////////////////////////
  // Constructor
  /////////////////////////////////////////////////////////////////////////////
  SerialBuffer::SerialBuffer(size_t size)
  {
    mBuffer.reserve(size);
    clear();
  }

  /////////////////////////////////////////////////////////////////////////////
  // append (buffer)
  /////////////////////////////////////////////////////////////////////////////
  void SerialBuffer::append(const uint8_t* data, size_t count)
  {
    mBuffer.insert(mBuffer.end(), data, data + count);
    updateMsgLength();
  }

  /////////////////////////////////////////////////////////////////////////////
  // append (string)
  /////////////////////////////////////////////////////////////////////////////
  void SerialBuffer::append(const std::string& str)
  {
    append(reinterpret_cast<const uint8_t*>(str.data()), str.length() + 1);
  }

  /////////////////////////////////////////////////////////////////////////////
  // clear
  /////////////////////////////////////////////////////////////////////////////
  void SerialBuffer::clear()
  {
    mBuffer.resize(sizeof(MsgHeader));
    updateMsgLength();
    mReadIndex = mBuffer.size();
  }

  /////////////////////////////////////////////////////////////////////////////
  // msgID
  /////////////////////////////////////////////////////////////////////////////
  uint32_t SerialBuffer::msgID()
  {
    return getHeader()->networkToHost().id;
  }

  /////////////////////////////////////////////////////////////////////////////
  // read (buffer)
  /////////////////////////////////////////////////////////////////////////////
  bool SerialBuffer::read(uint8_t* data, size_t count)
  {
    bool valid = false;
    if(numReadBytesRemaining() >= count)
    {
      memcpy(data, &mBuffer[mReadIndex], count);
      mReadIndex += count;
      valid = true;
    }

    return valid;
  }

  /////////////////////////////////////////////////////////////////////////////
  // read (string)
  /////////////////////////////////////////////////////////////////////////////
  bool SerialBuffer::read(std::string& str)
  {
    bool valid = false;
    auto it = std::find(mBuffer.begin() + mReadIndex, mBuffer.end(), 0);
    if(it != mBuffer.end())
    {
      str = reinterpret_cast<const char*>(&mBuffer[mReadIndex]);
      mReadIndex += str.length() + 1;
      valid = true;
    }

    return valid;
  }

  /////////////////////////////////////////////////////////////////////////////
  // setMsgID
  /////////////////////////////////////////////////////////////////////////////
  void SerialBuffer::setMsgID(uint32_t id)
  {
    auto* pHeader = getHeader();
    pHeader->id   = id;
    pHeader->id   = pHeader->hostToNetwork().id;
  }

  /////////////////////////////////////////////////////////////////////////////
  // numReadBytesRemaining
  /////////////////////////////////////////////////////////////////////////////
  size_t SerialBuffer::numReadBytesRemaining() const
  {
    return(mBuffer.size() - mReadIndex);
  }

  /////////////////////////////////////////////////////////////////////////////
  // getHeader
  /////////////////////////////////////////////////////////////////////////////
  MsgHeader* SerialBuffer::getHeader()
  {
    return reinterpret_cast<MsgHeader*>(&mBuffer[0]);
  }

  /////////////////////////////////////////////////////////////////////////////
  // updateMsgLength
  /////////////////////////////////////////////////////////////////////////////
  void SerialBuffer::updateMsgLength()
  {
    uint32_t length = mBuffer.size();
    auto* pHeader   = getHeader();
    pHeader->length = length;
    pHeader->length = pHeader->hostToNetwork().length;
  }

} // namespace System
